#ifndef _SEGA_DREAMCAST_CORRUPTION_H
#define _SEGA_DREAMCAST_CORRUPTION_H

#include <string>
#include <sstream>
#include "corrupt.h"
#include "img/img.h"

#include "dreamcastcorruptioninfo.h"

class DreamcastCorruption : public Corruption
{
public:
  DreamcastCorruption();
  DreamcastCorruption(std::string filename);
  ~DreamcastCorruption();

  virtual void corrupt();

  virtual void initialize(std::string);
  virtual bool valid();
  virtual bool valid_byte(uint8_t byte, uint32_t location);
  virtual void print_header();
  virtual void parse(std::vector<std::string>);
  virtual void save(std::string filename);

private:
  std::unique_ptr<DreamcastCorruptionInfo> info;
  std::unique_ptr<IMG> rom;

  std::string m_original_file;  //  Original filename
  std::string m_temp_file;      //  Temp file name
  bool m_saved;
};

#endif
