#ifndef _GENESIS_CORRUPTION_H
#define _GENESIS_CORRUPTION_H

#include "corrupt.h"

#include "genesis_except.h"
#include "genesis_header.h"
#include "genesiscorruptioninfo.h"

class GenesisCorruption : public Corruption
{
public:
  GenesisCorruption();
  GenesisCorruption(std::string filename);
  ~GenesisCorruption();

  virtual void corrupt();
  virtual bool valid();
  virtual bool valid_byte(uint8_t byte, uint32_t location);
  virtual void print_header();
  virtual void parse(std::vector<std::string> args);
  virtual void initialize(std::string filename);
  virtual void save(std::string filename);

private:
  std::unique_ptr<GenesisCorruptionInfo> info;
  std::unique_ptr<GenesisHeader> header;

  static bool is_branch(uint16_t instruction);

  uint16_t checksum();
};

#endif
