#ifndef _NINTENDO_FILE_PROTECTION_H
#define _NINTENDO_FILE_PROTECTION_H

#include <vector>
#include <memory>
#include <cstdint>
#include <random>

#include "log.h"

#include "nintendocorruptioninfo.h"
#include "yaz0.h"

class NintendoFile
{
public:
  virtual ~NintendoFile();

  static std::vector<uint8_t> start(std::string file, std::vector<std::string>& args);
  static std::vector<uint8_t> start(std::vector<uint8_t>& data, std::vector<std::string>& args, std::string filename = "");
  static void corrupt(std::vector<uint8_t>& data, std::vector<std::string>& args);

  virtual bool valid_byte() = 0;
private:
  template<typename T> static void corrupt(std::vector<uint8_t>& data, std::vector<std::string> args);
};

#include "rarc_file.h"
#include "bck_file.h"
#include "bmd_file.h"
#include "bti_file.h"
#include "btp_file.h"
#endif
