#include "nintendocorruptioninfo.h"

#include <iostream>

NintendoCorruptionInfo::NintendoCorruptionInfo(std::vector<std::string>& args)
{
  for (uint32_t i = 0; i < args.size(); i++)
  {
    auto& arg = args[i];
    std::cout << arg << std::endl;
    if (arg == "-s" || arg == "--step")
    {
      this->step = Util::to_int32(args[++i]);
    }
    else if (arg == "-h" || arg == "--shift")
    {
      this->value = this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::Shift;
    }
    else if (arg == "-w" || arg == "--swap")
    {
      this->value = this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::Swap;
    }
    else if (arg == "-a" || arg == "--add")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::Add;
    }
    else if (arg == "-t" || arg == "--set")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::Set;
    }
    else if (arg == "-r" || arg == "--random")
    {
      this->type = CorruptionType::Random;
    }
    else if (arg == "--rotate-left")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::RotateLeft;
    }
    else if (arg == "--rotate-right")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::RotateRight;
    }
    else if (arg == "--logical-and")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::LogicalAnd;
    }
    else if (arg == "--logical-or")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::LogicalOr;
    }
    else if (arg == "--logical-xor")
    {
      this->value = Util::to_int32(args[++i]);
      this->type = CorruptionType::LogicalXor;
    }
    else if (arg == "--logical-complement")
    {
      this->type = CorruptionType::LogicalComplement;
    }
    else if (arg == "-b" || arg == "--start")
    {
      this->start = Util::to_int32(args[++i]);
    }
    else if (arg == "-e" || arg == "--stop")
    {
      this->end = Util::to_int32(args[++i]);
    }
    else if (arg == "-o" || arg == "--out")
    {
      this->outfile = args[i + 1];
      i++;
    }
    else
    {
      //throw InvalidArgumentException(arg + " is not a recognized flag.");
    }
  }
}