#ifndef _RARC_CORRUPTION_INFO_H
#define _RARC_CORRUPTION_INFO_H

#include <boost/algorithm/string.hpp>
#include <vector>

#include "corruption_exceptions.h"
#include "corruptioninfo.h"
#include "helpers.h"

struct RARCCorruptionInfo : public CorruptionInfo
{
public:
  RARCCorruptionInfo(std::vector<std::string>& args);
  ~RARCCorruptionInfo();

  inline void add_file(std::string filename)
  {
    this->file_list.push_back(filename);
  }

  inline std::vector<std::string> files()
  {
    return std::vector<std::string>(this->file_list);
  }

private:
  std::vector<std::string> file_list;
};

#endif
