#ifndef _CORRUPTION_INFO_H
#define _CORRUPTION_INFO_H

#include <cstdint>
#include <string>
#include <limits>

enum CorruptionType
{
  None,
  Shift,
  Swap,
  Add,
  Set,
  Random,
  RotateLeft,
  RotateRight,
  LogicalAnd,
  LogicalOr,
  LogicalXor,
  LogicalComplement
};

struct CorruptionInfo
{
  CorruptionInfo();
  ~CorruptionInfo() {};

  std::string outfile;
  
  //  What type of corruption
  CorruptionType type;

  //  Basic information
  uint32_t step;
  uint32_t start;
  uint32_t end;

  uint32_t value;
};

#endif
